<?php declare(strict_types=1);

namespace App\Form;

use App\Service\WhoAreYou;
use App\Entity\FoodOrder;
use App\Entity\Vendor;
use Override;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class FoodOrderType extends AbstractType
{
    public function __construct(
        private readonly WhoAreYou $who
    ) {}

    #[Override]
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('startedBy', TextType::class, [
                'data' => $this->who->username,
            ])
            ->add(
                'vendor',
                EntityType::class,
                [
                    'class' => Vendor::class,
                    'choice_label' => 'name',
                    'multiple' => false,
                ],
            )
            ->add('startedAt');
    }

    #[Override]
    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => FoodOrder::class,
        ]);
    }
}
