<?php declare(strict_types=1);

namespace App\Service;

use Override;
use Stringable;
use Symfony\Bridge\Twig\AppVariable;

final class WhoAreYou implements Stringable
{
    public string $username = '';

    public function __construct(AppVariable $appVariable)
    {
        $this->username = $appVariable->getRequest()?->cookies?->get('username', '')
            ?? '';
    }

    public function isKnown(): bool
    {
        return $this->username !== '';
    }

    #[Override]
    public function __toString(): string
    {
        return $this->username;
    }
}
